import type { CallbackModelDiff, ComponentsModelDiff, ContactModelDiff, Diff, DiscriminatorModelDiff, EncodingModelDiff, ExampleModelDiff, ExternalDocumentationModelDiff, HeaderModelDiff, InfoModelDiff, LicenseModelDiff, LinkModelDiff, ListDiff, MapDiff, MediaTypeModelDiff, OpenAPIModelDiff, ParameterModelDiff, PathItemModelDiff, PathsModelDiff, RequestBodyModelDiff, ResponseModelDiff, SchemaModelDiff, SecuritySchemaModelDiff, ServerModelDiff, ServerVariableModelDiff, SetDiff, TagModelDiff, XMLModelDiff } from './types';
import type { JSONValue, Nullable } from '@fresha/api-tools-core';
import type { CallbackModel, HeaderModel, LinkModel, RequestBodyModel, SecuritySchemaModel, ComponentsModel, ContactModel, DiscriminatorModel, ExampleModel, ExternalDocumentationModel, InfoModel, LicenseModel, OpenAPIModel, ParameterModel, ResponseModel, SchemaModel, ServerModel, ServerVariableModel, SpecificationExtensionsModel, TagModel, XMLModel, MediaTypeModel, EncodingModel, PathItemModel, PathsModel } from '@fresha/openapi-model/build/3.0.3';
export declare class Differ {
    valueDiff<T>(from: T, to: T): Diff<T> | undefined;
    valueDiff2<T>(from: T | undefined, to: T | undefined): Diff<T> | undefined;
    setIterDiff<T>(from: IterableIterator<T>, to: IterableIterator<T>): SetDiff<T> | undefined;
    extensionsDiff(from: Nullable<SpecificationExtensionsModel> | undefined, to: Nullable<SpecificationExtensionsModel> | undefined): MapDiff<Diff<JSONValue>> | undefined;
    openapiDiff(from: OpenAPIModel, to: OpenAPIModel): OpenAPIModelDiff | undefined;
    pathsDiff(from: PathsModel, to: PathsModel): PathsModelDiff | undefined;
    pathItemDiff(from: PathItemModel, to: PathItemModel): PathItemModelDiff | undefined;
    infoDiff(from: InfoModel, to: InfoModel): InfoModelDiff | undefined;
    contactDiff(from: ContactModel, to: ContactModel): ContactModelDiff | undefined;
    licenseDiff(from: LicenseModel, to: LicenseModel): LicenseModelDiff | undefined;
    listDiff<TItem, TItemDiff extends Diff<TItem>>(from: IterableIterator<TItem>, to: IterableIterator<TItem>, keyFn: (item: TItem) => string, itemDiffFn: (item1: TItem, item2: TItem) => TItemDiff | undefined): ListDiff<TItem, TItemDiff> | undefined;
    mapDiff<TItem, TItemDiff extends Diff<TItem>>(fromIter: IterableIterator<[string, TItem]>, toIter: IterableIterator<[string, TItem]>, itemDiffFn: (item1: TItem, item2: TItem) => TItemDiff | undefined): MapDiff<TItemDiff> | undefined;
    serverListDiff(from: IterableIterator<ServerModel>, to: IterableIterator<ServerModel>): ListDiff<ServerModel, ServerModelDiff> | undefined;
    serverDiff(from: ServerModel, to: ServerModel): ServerModelDiff | undefined;
    serverVariableMapDiff(from: ServerModel, to: ServerModel): MapDiff<ServerVariableModelDiff> | undefined;
    serverVariableDiff(from: ServerVariableModel, to: ServerVariableModel): ServerVariableModelDiff | undefined;
    componentsDiff(from: ComponentsModel, to: ComponentsModel): ComponentsModelDiff | undefined;
    schemaDiff(from: SchemaModel, to: SchemaModel): SchemaModelDiff | undefined;
    responseDiff(from: ResponseModel, to: ResponseModel): ResponseModelDiff | undefined;
    mediaTypeDiff(from: MediaTypeModel, to: MediaTypeModel): MediaTypeModelDiff | undefined;
    encodingDiff(from: EncodingModel, to: EncodingModel): EncodingModelDiff | undefined;
    parameterDiff(from: ParameterModel, to: ParameterModel): ParameterModelDiff | undefined;
    exampleDiff(from: ExampleModel, to: ExampleModel): ExampleModelDiff | undefined;
    requestBodyDiff(from: RequestBodyModel, to: RequestBodyModel): RequestBodyModelDiff | undefined;
    headerDiff(from: HeaderModel, to: HeaderModel): HeaderModelDiff | undefined;
    securitySchemeDiff(from: SecuritySchemaModel, to: SecuritySchemaModel): SecuritySchemaModelDiff | undefined;
    linkDiff(from: LinkModel, to: LinkModel): LinkModelDiff | undefined;
    callbackDiff(from: CallbackModel, to: CallbackModel): CallbackModelDiff | undefined;
    discriminatorDiff(from: Nullable<DiscriminatorModel>, to: Nullable<DiscriminatorModel>): DiscriminatorModelDiff | undefined;
    xmlDiff(from: Nullable<XMLModel>, to: Nullable<XMLModel>): XMLModelDiff | undefined;
    tagListDiff(from: IterableIterator<TagModel>, to: IterableIterator<TagModel>): ListDiff<TagModel, TagModelDiff> | undefined;
    tagDiff(from: TagModel, to: TagModel): TagModelDiff | undefined;
    externalDocumentationDiff(from: Nullable<ExternalDocumentationModel>, to: Nullable<ExternalDocumentationModel>): ExternalDocumentationModelDiff | undefined;
}
//# sourceMappingURL=Differ.d.ts.map